#ifndef _ENC28J60_H_
#define _ENC28J60_H_

#include "typedefs.h"
#include "mmc_spi.h"

// Please use same configuration in mmc_spi.h too !
// Use ONE of these definitions only !
// #define USE_SPI0  //SPI0 Module, slow, max. 7.5MHz SPI at 60MHz speed
// #define USE_SPI1  //SPI1 SSP Module, fast, max. 30MHz SPI at 60MHz speed

#ifdef USE_SPI0
 #define ENC28J60_DDR_CS	IODIR1
 #define ENC28J60_PORT_CS_PIN	IOPIN1
 #define ENC28J60_PORT_CS_SET	IOSET1
 #define ENC28J60_PORT_CS_CLR	IOCLR1
 #define ENC28J60_BIT_CS        24

 #define ENC28J60_DDR_RESET	IODIR1
 #define ENC28J60_PORT_RESET	IOPIN1
 #define ENC28J60_PORT_RES_SET	IOSET1
 #define ENC28J60_PORT_RES_CLR	IOCLR1
 #define ENC28J60_BIT_RESET     22
#endif

#ifdef USE_SPI1
 #define ENC28J60_DDR_CS	IODIR0
 #define ENC28J60_PORT_CS_PIN	IOPIN0
 #define ENC28J60_PORT_CS_SET	IOSET0
 #define ENC28J60_PORT_CS_CLR	IOCLR0
 #define ENC28J60_BIT_CS        13

 #define ENC28J60_DDR_RESET	IODIR0
 #define ENC28J60_PORT_RESET	IOPIN0
 #define ENC28J60_PORT_RES_SET	IOSET0
 #define ENC28J60_PORT_RES_CLR	IOCLR0
 #define ENC28J60_BIT_RESET     16
#endif

#define ENC28J60_CS_LO()    (ENC28J60_PORT_CS_CLR = (1<<ENC28J60_BIT_CS)) //CS auf Low
#define ENC28J60_CS_HI()    (ENC28J60_PORT_CS_SET = (1<<ENC28J60_BIT_CS))  //CS auf High

#define ENC28J60_RESET_LO() (ENC28J60_PORT_RES_CLR = (1<<ENC28J60_BIT_RESET))
#define ENC28J60_RESET_HI() (ENC28J60_PORT_RES_SET = (1<<ENC28J60_BIT_RESET))

void enc28j60_io_init(void);

#if defined (USE_SPI0) && defined (USE_SPI1)
 #error "Define USE_SPI0 or USE_SPI1 only in enc28j60.h, NOT both !"
#endif

#if !defined (USE_SPI0) && !defined (USE_SPI1)
 #error "Define at least USE_SPI0 or USE_SPI1 in enc28j60.h !"
#endif

#endif

